VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cModule"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private mobjAcc95 As Object
Private mobjAcc97 As Object
Private mobjModOrig As Object
Private mobjModCopy As Object
Private mstrModName As String
Private mintModType As Integer
Private mintCounter As Integer

Private Sub Class_Initialize()
    mintCounter = 1
End Sub

Private Sub Class_Terminate()
    On Error Resume Next
    mintCounter = 0
    mobjAcc95.Docmd.Save AcObjectType.acModule, mobjModCopy.Name
    mobjAcc95.Docmd.Close AcObjectType.acModule, mobjModCopy.Name
    Set mobjModOrig = Nothing
    Set mobjModCopy = Nothing
End Sub

Public Property Set SetAcc95Instance(objAcc95 As Object)
    Set mobjAcc95 = objAcc95
End Property

Public Property Set SetAccess97Instance(objAcc97 As Object)
    Set mobjAcc97 = objAcc97
End Property

Public Property Let ModuleName(strName As String)
    mstrModName = strName
    With mobjAcc97
        .Docmd.OpenModule mstrModName
        Set mobjModOrig = .Modules(mstrModName)
        mintModType = mobjModOrig.Type
    End With
End Property

Public Property Get ModuleType() As Integer
    ModuleType = mintModType
End Property

Public Sub CloseModule()
    With mobjAcc97
        .Docmd.Close AcObjectType.acModule, mstrModName, AcCloseSave.acSaveNo
    End With
    With mobjAcc95
        .Docmd.Close AcObjectType.acModule, mstrModName, AcCloseSave.acSaveYes
    End With
End Sub

Public Sub CopyCode()
Dim objMdl As Object
Dim objNewMdl As Object
Dim strCode As String
Dim i As Integer
Dim j As Integer
Dim intMaxLines As Integer
Dim strNewMdl As String

    'This is messy... Do I really have to depend on
    'Screen's ActiveObject ??
    
    'First create and save the new module
    If fSaveNewModule Then
        With mobjModOrig
            intMaxLines = 1
            i = 1
            Do While i <= .CountOfLines
                strCode = .lines(i, intMaxLines)
                If InStr(strCode, "Option Compare Database") > 0 Or _
                        InStr(strCode, "Option Explicit") > 0 Then
                    i = i + 1
                    strCode = .lines(i, intMaxLines)
                    If InStr(strCode, "Option Compare Database") > 0 Or _
                        InStr(strCode, "Option Explicit") > 0 Then
                        i = i + 1
                        intMaxLines = 10
                        strCode = .lines(i, intMaxLines)
                    End If
                End If
                If Right$(strCode, 1) = "_" Then
                    j = 1
                    Do While Right$(strCode, 1) = "_"
                        strCode = .lines(i, intMaxLines + j)
                        j = j + 1
                    Loop
                    i = i + j
                End If
                mobjAcc95.InsertText strCode, mstrModName
                i = i + intMaxLines
            Loop
        End With
        mobjAcc95.Docmd.Save AcObjectType.acModule, mstrModName
    End If
End Sub

Private Function fSaveNewModule() As Boolean
Const conMOD_PREFIX = "Module"
Dim strNewModuleName As String

    On Error GoTo Err_handler
    
    'If there's already Module1, Module2 etc in the v8 database,
    'we need to increase the counter because inserting
    'a new module will default to SUFFIX+1
    '
    strNewModuleName = conMOD_PREFIX & mintCounter
    
    'This can get tricky
    With mobjAcc95
        .Docmd.DoMenuItem 1, 3, 5, 0, AcVersion.acMenuVer70
        'How else do we get the active module name
        .Docmd.SelectObject AcObjectType.acModule, strNewModuleName, False
        .Docmd.Save , mstrModName
    End With
    
    If strNewModuleName = mstrModName Then
        'increase counter and reassign NewModuleName
        mintCounter = mintCounter + 1
    End If

    
    fSaveNewModule = True
Exit_Here:
    Exit Function
Err_handler:
    fSaveNewModule = False
    Resume Exit_Here
End Function
