VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Access Downsizer"
   ClientHeight    =   4305
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5625
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4305
   ScaleWidth      =   5625
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Picture3 
      BorderStyle     =   0  'None
      Height          =   495
      Left            =   2760
      Picture         =   "frmMain.frx":0442
      ScaleHeight     =   495
      ScaleWidth      =   495
      TabIndex        =   6
      Top             =   1680
      Width           =   495
   End
   Begin VB.PictureBox Picture1 
      BorderStyle     =   0  'None
      Height          =   2295
      Left            =   480
      Picture         =   "frmMain.frx":0580
      ScaleHeight     =   2295
      ScaleWidth      =   4695
      TabIndex        =   4
      Top             =   360
      Width           =   4695
      Begin VB.PictureBox Picture2 
         BorderStyle     =   0  'None
         Height          =   495
         Left            =   0
         Picture         =   "frmMain.frx":74D4
         ScaleHeight     =   495
         ScaleWidth      =   495
         TabIndex        =   5
         Top             =   1320
         Width           =   495
      End
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "&Exit"
      Height          =   375
      Left            =   4440
      TabIndex        =   3
      Top             =   3840
      Width           =   975
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "&Start"
      Height          =   375
      Left            =   4440
      TabIndex        =   0
      Top             =   3360
      Width           =   975
   End
   Begin VB.PictureBox picMouse 
      Height          =   615
      Left            =   3000
      Picture         =   "frmMain.frx":7612
      ScaleHeight     =   555
      ScaleWidth      =   435
      TabIndex        =   9
      Top             =   3240
      Visible         =   0   'False
      Width           =   495
   End
   Begin VB.Label lblName3 
      Caption         =   "The Access Web"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   -1  'True
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FF0000&
      Height          =   255
      Left            =   2400
      TabIndex        =   10
      Top             =   3960
      Width           =   1335
   End
   Begin VB.Label lblDisclaimer 
      ForeColor       =   &H00000000&
      Height          =   705
      Left            =   120
      TabIndex        =   1
      Top             =   3240
      Width           =   3615
   End
   Begin VB.Label lblName2 
      Caption         =   "Email Terry"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   -1  'True
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FF0000&
      Height          =   255
      Left            =   1080
      TabIndex        =   8
      Top             =   3960
      Width           =   975
   End
   Begin VB.Label lblName1 
      Caption         =   "Email Dev"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   -1  'True
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FF0000&
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   3960
      Width           =   855
   End
   Begin VB.Label lblVersion 
      Alignment       =   1  'Right Justify
      Height          =   225
      Left            =   2640
      TabIndex        =   2
      Top             =   2880
      Width           =   2805
   End
   Begin VB.Line Line1 
      BorderColor     =   &H80000005&
      BorderWidth     =   2
      Index           =   0
      X1              =   15
      X2              =   5564
      Y1              =   3180
      Y2              =   3180
   End
   Begin VB.Line Line1 
      BorderColor     =   &H00808080&
      BorderStyle     =   6  'Inside Solid
      Index           =   1
      X1              =   0
      X2              =   5564
      Y1              =   3165
      Y2              =   3165
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const conERR_WRONG_VERSION = vbObjectError + 10
Private Const conERR_GENERIC = vbObjectError + 20
Private Const conERR_NOFILE = vbObjectError + 30
Private Const conERR_SAMEFILE = vbObjectError + 40

Private Declare Function apiShellExecute Lib "shell32.dll" _
    Alias "ShellExecuteA" _
    (ByVal hWnd As Long, _
    ByVal lpOperation As String, _
    ByVal lpFile As String, _
    ByVal lpParameters As String, _
    ByVal lpDirectory As String, _
    ByVal nShowCmd As Long) _
    As Long


Private Sub cmdExit_Click()
    On Error Resume Next
    Unload frmStatus
    Unload Me
End Sub

Private Sub cmdStart_Click()
Dim cDlg As New cDialog
Dim dbRemote As DAO.Database
Dim strOrigMDB As String
Dim strNewMDB As String
    On Error GoTo Err_handler
    With cDlg
        .Title = "Please select an Access 97 database to Downsize..."
        .hWnd = Me.hWnd
        .ModeOpen = True
        .StartDir = CurDir()
        .Filter = "Access databases (*.mdb)|*.mdb"
        .DefaultExtension = "MDB"
        strOrigMDB = .Action
    End With
    Set cDlg = Nothing
    
    If strOrigMDB = vbNullString Then Err.Raise conERR_NOFILE
    
    'Status form opened here
    Load frmStatus
    With frmStatus
        .Show
        .Activate
        .lblStatus.Caption = "Loading database " & vbCrLf & strOrigMDB
        .Refresh
    End With
    
    If Not fIs97MDB(strOrigMDB) Then Err.Raise conERR_WRONG_VERSION
    
    Set cDlg = New cDialog
    With cDlg
        .Title = "Please select the Access 95 database name to save as"
        .hWnd = Me.hWnd
        .ModeOpen = False
        .StartDir = CurDir()
        .Filter = "Access databases (*.mdb)|*.mdb"
        .DefaultExtension = "MDB"
        strNewMDB = .Action
    End With
    Set cDlg = Nothing
    
    If strNewMDB = vbNullString Then Err.Raise conERR_NOFILE
    
    'check to see if the target name is the same as the original name
    If strNewMDB = strOrigMDB Then Err.Raise conERR_SAMEFILE
    
    If Len(Dir(strNewMDB)) > 0 Then Kill strNewMDB
    
    With frmStatus
        .Activate
        .Picture1.Cls
        .lblStatus.Caption = "Collecting information for export...."
        .Refresh
    End With
    
    Do While Len(Dir(strNewMDB)) > 0: DoEvents: Loop
'********************************************************
'First instance of Access97 started here
'********************************************************
    Set dbRemote = DBEngine.Workspaces(0).CreateDatabase(strNewMDB, _
                                        dbLangGeneral, _
                                        dbVersion30)
    DoEvents
    
    dbRemote.Close
    Set dbRemote = Nothing
    DoEvents
    Me.WindowState = vbMinimized
    Call sStartMain(strOrigMDB, strNewMDB)
Exit_Here:
    On Error Resume Next
    Unload frmStatus
    Unload Me
    Set cDlg = Nothing
    Exit Sub
Err_handler:
    Select Case Err
        Case conERR_WRONG_VERSION:
            MsgBox "The database you selected " & vbCrLf & "'" & strOrigMDB & "'" _
                & vbCrLf & "is not an Access 97 database." & vbCrLf & "Please try again.", _
                vbExclamation + vbOKOnly, "Downsizer: Wrong version"
        Case conERR_GENERIC:
        
        Case conERR_SAMEFILE:
            MsgBox "The target database " & vbCrLf & vbCrLf _
                & strNewMDB & vbCrLf & vbCrLf & "cannot be the same as the Source database " _
                & vbCrLf & vbCrLf & strOrigMDB & vbCrLf _
                & vbCrLf & "Please try again.", _
                vbExclamation + vbOKOnly, "Downsizer: Must specify unique names"
                
        Case conERR_NOFILE:
            MsgBox "The Access Downsizer cannot work without a database." & vbCrLf _
                & vbCrLf & "Please try again.", _
                vbExclamation + vbOKOnly, "Downsizer: No Database specified."
        
        Case Else:
            MsgBox "Err#: " & Err.Number & vbCrLf & Err.Description, vbCritical + vbOKOnly, _
                "Runtime Error"
    End Select
    Resume Exit_Here
        
End Sub

Private Sub Form_Load()
    lblDisclaimer.Caption = App.LegalCopyright & vbCrLf & _
        "For updates and other utilities, visit " & vbCrLf _
        & App.CompanyName
    lblVersion.Caption = "Version " & App.Major & "." & App.Minor & "." & App.Revision
    With Me.lblName1
        .MouseIcon = Me.picMouse.Picture
        .MousePointer = vbCustom
    End With
    With Me.lblName2
        .MouseIcon = Me.picMouse.Picture
        .MousePointer = vbCustom
    End With
    With Me.lblName3
        .MouseIcon = Me.picMouse.Picture
        .MousePointer = vbCustom
    End With
End Sub

Private Sub lblName1_Click()
    Call apiShellExecute(0&, "open", _
        "mailto:ashishd@micromodeling.com", _
            vbNullString, vbNullString, 1)
End Sub

Private Sub lblName2_Click()
    Call apiShellExecute(0&, "open", _
        "mailto:terry.kreft@mps.co.uk", _
            vbNullString, vbNullString, 1)
End Sub

Private Sub lblName3_Click()
    Call apiShellExecute(0&, "open", _
        "http://home.att.net/~dashish", _
            vbNullString, vbNullString, 1)
End Sub
