Attribute VB_Name = "modMain"
Option Explicit

Public pobjAcc97 As Object
Public pobjAcc95 As Object

Public Const pconQ = """"

Sub sStartMain(str97MDB As String, str95MDB As String)
    Dim clsTbl As cTable
    Dim clsQry As cQuery
    Dim clsForm As cForm
    Dim clsModule As cModule
    Dim clsReport As cReport
    Dim i As Integer, intMax As Integer
    Dim lodb97 As Database
    Dim lodb95 As Database
    Dim strObjectName As String
    

    On Error Resume Next
    Set pobjAcc97 = Nothing
    
    'Second instance of Access 97 started here
    Do While pobjAcc97 Is Nothing
      i = i + 1
      If i = 50 Then
        i = 0
        Exit Do
      End If
      Set pobjAcc97 = GetObject(str97MDB)
      DoEvents
    Loop
    
    On Error GoTo Err_handler
    Set lodb97 = pobjAcc97.CurrentDB
    
    'Start Tables
    Set clsTbl = New cTable
    With clsTbl
        Set .SetAccess97MDB = lodb97
        Set .SetAccess97Instance = pobjAcc97
        .Access95MDB = str95MDB
        intMax = lodb97.TableDefs.Count
        If intMax > 0 Then 'which it will be in this case
            With frmStatus
                .Activate
                Call sClearMeter
                .Interval = 1
                .SetScaleWidth = intMax
            End With
            
            For i = 1 To intMax
                strObjectName = lodb97.TableDefs(i - 1).Name
                If Left$(strObjectName, 4) <> "MSys" And _
                        Left$(strObjectName, 1) <> "~" Then
                    Call sUpdateMeter("Copying table " & pconQ & strObjectName & pconQ)
                    clsTbl.CopyTables (strObjectName)
                Else
                    Call sUpdateMeter("Not processing system table " & pconQ & strObjectName & pconQ)
                End If
            Next
            
            'Create Relations
            Call sClearMeter
            Call sUpdateMeter("Creating Relations")
            Set lodb95 = DBEngine.OpenDatabase(str95MDB)
            Call clsTbl.sCreateRelations(lodb95)
        End If
    End With
    
    Set clsTbl = Nothing
    
    
    'On to Queries
    Set clsQry = New cQuery
    With clsQry
        Set .SetAccess95MDB = lodb95
        Set .SetAccess97Instance = pobjAcc97
        Set .SetAccess97MDB = lodb97
        .Access95MDB = str95MDB
        intMax = lodb97.QueryDefs.Count
        If intMax > 0 Then
            With frmStatus
                .Activate
                .Interval = 1
                .SetScaleWidth = intMax
            End With
            Call sClearMeter
            
            For i = 1 To intMax
                strObjectName = lodb97.QueryDefs(i - 1).Name
                If Left$(strObjectName, 1) <> "~" Then
                    Call sUpdateMeter("Creating query " & pconQ & strObjectName & pconQ)
                    Call clsQry.CopyQuery(strObjectName)
                Else
                    Call sUpdateMeter("Not processing temp query " & pconQ & strObjectName & pconQ)
                End If
            Next
        End If
    End With
    Set clsQry = Nothing
    Call sClearMeter

    'Now the forms
    lodb95.Close
    Set lodb95 = Nothing
    DoEvents
    
    frmStatus.SetCaption = "Launching Access 95 instance..."
    frmStatus.Refresh
    
    Set pobjAcc95 = GetObject(str95MDB, "Access.Application.7")
    Set clsForm = New cForm
    
     'Show the second status bar in frmStatus
    frmStatus.ShowSecondStatus
    
    With clsForm
        Set .SetAcc95Instance = pobjAcc95
        Set .SetAccess97Instance = pobjAcc97
        intMax = lodb97.Containers!Forms.Documents.Count
        If intMax > 0 Then
            With frmStatus
                .Activate
                .Interval = 1
                .SetScaleWidth = intMax
            End With
            
            Call sClearMeter
            
            For i = 1 To intMax
                strObjectName = lodb97.Containers!Forms.Documents(i - 1).Name
                If Left$(strObjectName, 1) <> "~" Then
                    Call sUpdateMeter("Creating Form " & pconQ & strObjectName & pconQ)
                    clsForm.SetSourceForm = strObjectName
                    Call clsForm.CopyForm
                    Call clsForm.SaveForm
                Else
                    Call sUpdateMeter("Ignoring temporary Form " & pconQ & strObjectName & pconQ)
                End If
            Next
        End If
    End With
    Set clsForm = Nothing
    Call sClearMeter
    Call sClearSubMeter
    
    'Skip macros, real pain
    
    'On to the reports
    Set clsReport = New cReport
    With clsReport
        Set .SetAcc95Instance = pobjAcc95
        Set .SetAccess97Instance = pobjAcc97
        intMax = lodb97.Containers!Reports.Documents.Count
        If intMax > 0 Then
            With frmStatus
                .Activate
                .Interval = 1
                .SetScaleWidth = intMax
            End With
            
            Call sClearMeter
            Call sClearSubMeter
            
            For i = 1 To intMax
                strObjectName = lodb97.Containers!Reports.Documents(i - 1).Name
                If Left$(strObjectName, 1) <> "~" Then
                    Call sUpdateMeter("Creating Report " & pconQ & strObjectName & pconQ)
                    clsReport.SetSourceReport = strObjectName
                    Call clsReport.CopyReport
                    Call clsReport.SaveReport
                Else
                    Call sUpdateMeter("Ignoring temporary report " & pconQ & strObjectName & pconQ)
                End If
            Next
        End If
    End With
    Set clsReport = Nothing
    
    Call sHideSecondMeter
    
    'Grab the modules
    Set clsModule = New cModule
    With clsModule
        Set .SetAcc95Instance = pobjAcc95
        Set .SetAccess97Instance = pobjAcc97
        intMax = lodb97.Containers!Modules.Documents.Count
        If intMax > 0 Then
            With frmStatus
                .Activate
                .Interval = 1
                .SetScaleWidth = intMax
            End With
            
            Call sClearMeter
            Call frmStatus.HideSecondStatus
            
            For i = 1 To intMax
                strObjectName = lodb97.Containers!Modules.Documents(i - 1).Name
                If Left$(strObjectName, 1) <> "~" Then
                    With clsModule
                        .ModuleName = strObjectName
                        If .ModuleType = AcModuleType.acStandardModule Then
                            Call sUpdateMeter("Creating standard module " & pconQ & strObjectName & pconQ)
                            .CopyCode
                            .CloseModule
                        ElseIf .ModuleType = AcModuleType.acClassModule Then
                            Call sUpdateMeter("Ignoring Class Module " & pconQ & strObjectName & pconQ)
                        End If
                    End With
                End If
            Next
        End If
    End With
    Call sClearMeter
    
    'Get the main database properties
    frmStatus.SetCaption = "Assigning database properties...."
    Call sAssignDBProps
    
    str97MDB = pobjAcc97.CurrentDB.Name
    str95MDB = pobjAcc95.CurrentDB.Name
    pobjAcc97.quit
    pobjAcc95.quit
    Set pobjAcc97 = Nothing
    Set pobjAcc95 = Nothing
    
    MsgBox "The Downsizer successfully finished converting " & vbCrLf & "the Microsoft Access 97 database " _
        & vbCrLf & vbCrLf & str97MDB & vbCrLf & vbCrLf & "into a Microsoft Access 95 database " _
        & vbCrLf & vbCrLf & str95MDB, vbInformation + vbOKOnly, "Finished!"
    
Exit_Here:
    On Error Resume Next
    pobjAcc97.quit
    pobjAcc95.quit
    Set pobjAcc97 = Nothing
    Set pobjAcc95 = Nothing
    Unload frmStatus
    Exit Sub
Err_handler:
    MsgBox "Err#: " & Err.Number & vbCrLf & Err.Description, vbCritical + vbOKOnly, _
                "Runtime Error"
    Resume Exit_Here
End Sub

Function fIs97MDB(strRemoteDB As String) As Boolean
    Dim lowrk As DAO.Workspace
    Dim lodb As DAO.Database
    On Error GoTo Err_handler
    
    Set lowrk = CreateWorkspace("DownsizerWorkSpace", "Admin", "", dbUseJet)
    Set lodb = lowrk.OpenDatabase(strRemoteDB)
    With lodb
        fIs97MDB = (.Properties("AccessVersion") > "07.00")
    End With
Exit_Here:
    lodb.Close
    Set lodb = Nothing
    lowrk.Close
    Set lowrk = Nothing
    DoEvents
    Exit Function
Err_handler:
    fIs97MDB = False
    Resume Exit_Here
End Function

Sub sAssignDBProps()
Dim prp97 As Object
Dim prp95 As Object
Dim db97 As Object
Dim db95 As Object
Const conPROP_NOT_EXIST = 3270

    On Error GoTo ErrHandler
    Set db97 = pobjAcc97.CurrentDB
    Set db95 = pobjAcc95.CurrentDB
    For Each prp97 In db97.Properties
        db95.Properties(prp97.Name) = prp97.Value
    Next
    
ExitHere:
    On Error Resume Next
    Set prp97 = Nothing
    Set prp95 = Nothing
    Set db97 = Nothing
    Set db95 = Nothing
    Exit Sub
    
ErrHandler:
    If Err.Number = conPROP_NOT_EXIST Then
        With prp97
            Set prp95 = db95.CreateProperty(.Name, .Type, .Value)
            db95.Properties.Append prp95
        End With
        Resume Next
    Else
        Resume ExitHere
    End If
End Sub

Sub sUpdateMeter(strText As String)
    With frmStatus
        .UpdateText = strText
        .Increment
        .Refresh
    End With
End Sub

Sub sClearMeter()
    Call frmStatus.ClearProgressBar
    frmStatus.Refresh
End Sub

Sub sClearSubMeter()
    Call frmStatus.ClearSubProgressBar
    frmStatus.Refresh
End Sub

Sub sHideSecondMeter()
    Call frmStatus.HideSecondStatus
    frmStatus.Refresh
End Sub
