VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cTable"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private mobjAcc97 As Object
Private mstr95MDB As String
Private mdbAcc97 As Database

Private Type tLinkedTableInfo
    strTableName As String
    strNewName As String
    strConnectString As String
    strSourceTable As String
End Type

Private Const conERR_NO_OBJECT = vbObjectError + 1

Private Sub Class_Terminate()
    Set mdbAcc97 = Nothing
    Set mobjAcc97 = Nothing
End Sub

Public Property Set SetAccess97MDB(db97 As Database)
    Set mdbAcc97 = db97
End Property

Public Property Set SetAccess97Instance(objAcc97 As Object)
    Set mobjAcc97 = objAcc97
End Property

Public Sub DetectLinkedTables()

End Sub

Public Property Let Access95MDB(strMDB As String)
    mstr95MDB = strMDB
End Property

Public Sub CopyTables(strTableName As String)
    With mdbAcc97
            mobjAcc97.DoCmd.TransferDatabase transferType:=acExport, _
                                        DatabaseType:="Microsoft Access", _
                                        DatabaseName:=mstr95MDB, _
                                        ObjectType:=acTable, _
                                        Source:=strTableName, _
                                        Destination:=strTableName, _
                                        StructureOnly:=False
    End With
End Sub


Public Sub sCreateRelations(objDB As Database)
Dim rel As Relation, newRel As Relation
Dim blnErr As Boolean
Dim fld As Field, newFld As Field


    On Error GoTo Err_handler
    
    If mdbAcc97.Relations.Count = 0 Then Err.Raise conERR_NO_OBJECT
    
    With frmStatus
        .Interval = 1
        .SetScaleWidth = mdbAcc97.Relations.Count
    End With
    
    For Each rel In mdbAcc97.Relations
        With rel
            Set newRel = objDB.CreateRelation(.Name, _
                                                        .Table, _
                                                       .ForeignTable, _
                                                       .Attributes)
            blnErr = False
            Call sUpdateMeter("Creating relation for tables " & pconQ & _
                                newRel.Table & pconQ & " and " & pconQ & newRel.ForeignTable & pconQ)
            For Each fld In .Fields
                Set newFld = newRel.CreateField(fld.Name)
                newFld.ForeignName = fld.ForeignName
                On Error Resume Next
                newRel.Fields.Append newFld
                If Err <> False Then
                    Err.Raise Err.Number
                    blnErr = True
                End If
                On Error GoTo 0
          Next
            If Not (blnErr) Then objDB.Relations.Append newRel
       End With
    Next
    Set fld = Nothing
    Set rel = Nothing

Exit_Here:
    Exit Sub
Err_handler:
    Resume Exit_Here
End Sub


